# indzooomspeedgauge

[Flutter](https://flutter.io) IndzoomSpeedGauge widget package

![](indzooomspeedgauge_2.png)

### Getting Started

In order to use this package, do import
```dart
import 'package:indzooomspeedgauge/indzooomspeedgauge.dart';
```

Basic implementation can be done like below code:
```dart
import 'package:flutter/material.dart';
import 'package:indzooomspeedgauge/indzooomspeedgauge.dart';

void main() {
  runApp(
    Center(
      child: IndzoomSpeedGauge(
        size: 250,
        minValue: 0,
        maxValue: 180,
        currentValue: 76,
        warningValue: 150,
        displayText: 'mph',
      ),
    ),
  );
}
```

### Example App
You can find more examples from [Example App](example)


### API
In this table, you can find all attributes provided by this package:

| Attribute           | Default value                     | Description |
| ------------------- | --------------------------------- | ----------- |
| size                | 200                               | Min value to be displayed   |
| minValue            | 0                                 | Min value to be displayed   |
| maxValue            | 100                               | Max value to be displayed   |
| currentValue        | 0                                 | Set the current value       |
| warningValue        | 80                                | Set the current value       |

### Objects
```dart
class IndzoomSpeedGauge {

    final double size;
    final int minValue;
    final int maxValue;
    final int currentValue;
    final int warningValue;
    final Color backgroundColor;
    final Color meterColor;
    final Color warningColor;
    final Color kimColor;
    final TextStyle displayNumericStyle;
    final String displayText;
    final TextStyle displayTextStyle;
}
 ```


### Feedback

Feel free to [leave any feedback](https://github.com/giulianojordao/indzooomspeedgauge/issues) for helping support this package 🍻 
